<?php
require('../includes/config.php');
require('../includes/database.inc.php');
require('../includes/helpers.php');

$page_filter = array(
    'id'        => '\d+',
    'verbose'   => '\d+'
);

unset($state);
$state = array();
array_walk($page_filter, 'validate_input');

$database = new Database();
$database->Connect($site_config);

function count_category($category) {
	global $state, $database, $CombineCategoryChilds;

	$result = $database->Query("SELECT parent, count FROM categories WHERE id = ?",
                        array($category));

	if ($result->RecordCount() != 1) {
        echo "Unknown category id";
        exit(0);
    }

    $row = $result->FetchRow();
    if ($state['input']['verbose'])
        echo "Count is now: ".$row["count"]."<br/>\n";
    $database->Query("UPDATE categories SET count=count + 1 WHERE id = ?",
                        array($category));

    if ($CombineCategoryChilds && is_numeric($row["parent"])) {
        if ($row["parent"] != 1)
            count_category($row["parent"]);
    }
}

function count_link($link) {
	global $state, $database;
	$result = $database->Query("SELECT link, count, category FROM links WHERE id = ?",
                        array($link));
	if ($result->RecordCount() != 1) {
        echo "Unknown link id";
        exit(0);
    }

    $row = $result->FetchRow();
    if ($state['input']['verbose'])
        echo "Count is now: ".$row["count"]."<br/>\n";

    $database->Query("UPDATE links SET count=count + 1 WHERE id = ?",
            array($link));

    count_category($row["category"]);

    return $row["link"];
}

if (!is_numeric($state['input']['id'])) {
	echo "Not a number.<br/>\n";
	exit(0);
}

$location = count_link($state['input']['id']);
	
header("Location: $location");
?>
