<?php
error_reporting (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
require('../includes/config.php');
require('../includes/database.inc.php');
require('../includes/helpers.php');

$database = new Database();
$database->Connect($site_config);

#TODO: For later
#$version = get_db_version($DBDatabase);
#if ($version != 2)
#	die("Incorrect database version\n");

$default_user = get_db_var($database, "default_user");
$admin_user = get_db_var($database, "admin_user");

$mes_correct = 0;
$admin = 0;
$active_user = 0;
$debug = 0;
$user = "";

session_start();

$page_filter = array(
    'action'        => '\w+',
    'c_username'    => '\w+',
    'c_password'    => '.*',
    'c_password1'   => '.*',
    'c_password2'   => '.*',
    'id'            => '\d+',
    'c_id'          => '\d+',
    'c_category'    => '\d+',
    'c_name'        => '\w+',
    'c_link'        => '.*',
    'c_parent'      => '\d+',
    'show'          => '\w+',
    'user'          => '\w+',
    'mode'          => 'del|add|edit|list',
    'link'          => '\d+',
    'category'      => '\d+',
    'mtype'         => 'error|success|warning|info',
    'message'       => '.*',
    'extra_message' => '.*'
);

unset($state);
array_walk($page_filter, 'validate_input');

if ($state['input']['action'] == "submitlogin") {
    if (isset($_SESSION['user_id'])) {
        $_SESSION = array();
        session_destroy();
    }

    if (strlen($state['input']['c_username']) &&
            strlen($state['input']['c_password'])) 
    {
        $result = $database->Query('SELECT id, password FROM users WHERE '.
                'username = ?',
                array($state['input']['c_username']));

        if ($row = $result->FetchRow()) {
            $c_id = $row["id"];
            $c_password = $row["password"];

            if ($c_password == sha1($state['input']['c_password']))
            {
                $_SESSION['user_id'] = $c_id;
                $_SESSION['admin'] = 0;
                $_SESSION['show_id'] = $c_id;

                if ($state['input']['c_username'] == $admin_user)
                    $_SESSION['admin'] = 1;
            }
        }
    }
    if (!isset($_SESSION['user_id']))
    {
        echo "Failed to log in.<br/>\n";
    }
}

if ($state['input']['action'] == "submitlogoff") {
    $_SESSION = array();
    session_destroy();
}

// Guarantee that in a new session, the default account is viewed if nothing is selected.
//
if (!isset($_SESSION['show_id']))
	$user = $default_user;

if (isset($_SESSION['user_id'])) {
	$admin = $_SESSION['admin'];
	$state['user_id'] = $_SESSION['user_id'];
	$state['logged_on'] = true;
} else {
	$state['logged_on'] = false;
	$admin = 0;
	$state['user_id'] = -1;
}

function set_message($type, $message, $extra_message = '')
{
    global $state;

    $state['input']['mtype'] = $type;
    $state['input']['message'] = $message;
    $state['input']['extra_message'] = $extra_message;
}

function do_page_logic()
{
    global $state, $database, $mes_correct;

    if (!strlen($state['input']['action']) || !$state['logged_on'])
        return;

	if ($state['input']['action'] == 'submitaddcategory') {
		$c_name = $state['input']['c_name'];
		$c_parent = $state['input']['c_parent'];

		if (!strlen($c_name) || !strlen($c_parent)) {
			set_message('error', 'Failure: All values should be entered.');
            return;
        }

        $result = $database->InsertQuery(
                'INSERT INTO categories (name, parent, user) VALUES (?,?,?)',
                array($c_name, $c_parent, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: addcategory.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'Category is added.');
	}

	if ($state['input']['action'] == 'submiteditcategory') {
		$c_id = $state['input']['c_id'];
		$c_name = $state['input']['c_name'];
		$c_parent = $state['input']['c_parent'];

		if (!strlen($c_id) || !strlen($c_name) || !strlen($c_parent)) {
			set_message('error', 'Failure: All values should be entered.');
            return;
        }

		if ($c_id == $c_parent) {
			set_message('error', 'Failure: Cannot become own parent.');
            return;
        }

        $result = $database->Query(
                "UPDATE categories SET name = ?,".
                "parent = ? WHERE id = ? AND user = ?",
                array($c_name, $c_parent, $c_id, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: editcategory.');
            return;
		}

        if ($mes_correct)
            set_message('success', 'Category is modified.');
	}

	if ($state['input']['action'] == 'submitdelcategory') {
		$c_id = $state['input']['c_id'];
		$c_parent = $state['input']['c_parent'];

		if (!strlen($c_id) || !strlen($c_parent)) {
			set_message('error', 'Failure: All values should be entered.');
            return;
		}

        $result = $database->Query(
                "DELETE FROM links WHERE category = ? AND user = ?",
                array($c_id, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: delcategory.');
            return;
        }

        $result = $database->Query(
                "DELETE FROM categories WHERE id = ? AND user = ?",
                array($c_id, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: delcategory.');
            return;
        }

        $result = $database->Query(
                "UPDATE categories SET parent = ? WHERE parent = ? AND user = ?",
                array($c_parent, $c_id, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: delcategory.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'Category successfully deleted',
                'Links in category are deleted, category is deleted and child categories are updated.');
	}

	if ($state['input']['action'] == "submitaddlink") {
		$c_name = $state['input']['c_name'];
		$c_link = $state['input']['c_link'];
		$c_category = $state['input']['c_category'];

		if (!strlen($c_name) || !strlen($c_link) || !strlen($c_category)) {
			set_message('error', 'Failure: All values should be entered.');
            return;
		}

        $result = $database->InsertQuery(
                "INSERT INTO links (name, link, category, user) ".
                "VALUES (?,?,?,?)",
                array($c_name, $c_link, $c_category, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: addlink.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'Link is added.');
	}

	if ($state['input']['action'] == "submiteditlink") {
		$c_id = $state['input']['c_id'];
		$c_name = $state['input']['c_name'];
		$c_link = $state['input']['c_link'];
		$c_category = $state['input']['c_category'];

		if (!strlen($c_id) || !strlen($c_name) || !strlen($c_link) ||
				!strlen($c_category))
        {
			set_message('error', 'Failure: All values should be entered.');
            return;
		}

        $result = $database->Query(
				"UPDATE links SET name = ?, link = ?, category = ? ".
				"WHERE id = ? and user = ?",
                array($c_name, $c_link, $c_category, $c_id, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: editlink.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'Link is modified.');
	}

	if ($state['input']['action'] == "submitdellink") {
		$c_id = $state['input']['c_id'];

		if (!strlen($c_id)) {
			set_message('error', 'Failure: All values should be entered.');
            return;
		}

        $result = $database->Query(
                "DELETE FROM links WHERE id = ? AND user = ?",
                array($c_id, $state['user_id']));

        if ($result === FALSE) {
            set_message('error', 'Failure: dellink.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'Link is deleted.');
	}

	if ($state['input']['action'] == "submitadduser") {
		$c_username = $state['input']['c_username'];
		$c_password1 = $state['input']['c_password1'];
		$c_password2 = $state['input']['c_password2'];

		if (!strlen($c_username) || !strlen($c_password1) ||
			!strlen($c_password2))
        {
			set_message('error', 'Failure: All values should be entered.');
            return;
		}

		if ($c_password1 != $c_password2) {
			set_message('error', 'Failure: Passwords are not equal.');
            return;
		}

        $result = $database->InsertQuery(
				"INSERT INTO users (username, password) VALUES (?, SHA(?))",
				array($c_username, $c_password1));

        if ($result === FALSE) {
            set_message('error', 'Failure: adduser.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'User is added.');
	}

	if ($state['input']['action'] == "submitdeluser") {
		$c_id = $state['input']['c_id'];

		if (!strlen($c_id)) {
			set_message('error', 'Failure: All values should be entered.');
            return;
		}

        $result = $database->Query(
				"DELETE FROM links WHERE user = ?",
                array($c_id));

        if ($result === FALSE) {
            set_message('error', 'Failure: deluser.');
            return;
        }

        $result = $database->Query(
                "DELETE FROM categories WHERE user = ?",
                array($c_id));

        if ($result === FALSE) {
            set_message('error', 'Failure: deluser.');
            return;
        }

        $result = $database->Query(
				"DELETE FROM users WHERE id = ?",
                array($c_id));

        if ($result === FALSE) {
            set_message('error', 'Failure: deluser.');
            return;
        }

        if ($mes_correct)
            set_message('success', 'User successfully deleted',
                'Links for user are deleted, categories for user are deleted and the user is deleted.');
	}
}

do_page_logic();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<meta name="description" content="<?=$HTMLDescription?>"/>
<meta name="keywords" content="<?=$HTMLKeywords?>"/>
<title><?=$HTMLTitle?></title>
<link rel="stylesheet" href="<?=$HTMLStyleSheet?>" type="text/css"/>
<?=$HTMLHeader?>
</head>
<body>
<?
if (strlen($state['input']['mtype']))
{
    echo "<p>".$state['input']['mtype'].": ".$state['input']['message']."<br/>".
            $state['input']['extra_message']."</p>";
}

$show = $state['input']['show'];
if (!strlen($show)) $show = "main";

$user = $state['input']['user'];
if (!strlen($user) && !isset($_SESSION["show_id"])) $user = $default_user;

if (strlen($user)) {
	$result = $database->Query("SELECT id FROM users WHERE username = ?",
                    array($user));
	if ($result->RecordCount() == 1)
        $_SESSION["show_id"] = $result->fields[0];
	else
		$_SESSION["show_id"] = -1;
} 

$show_id = $_SESSION["show_id"];

if ($show == "login" || ($state['logged_on'] && $show_id == $state['user_id']))
	include ("../includes/startpage-".$show.".php");
else
	include ("../includes/startpage-main.php");
  
?>
</body>
</html>
